-- ****************************************************************************
-- ******************** (C) 2011 RadioComp ApS            *********************
-- ******************** Krakasvej 17                      *********************
-- ******************** DK-3400 Hilleroed, Denmark        *********************
-- ****************************************************************************
-- ****************** JESD204AB (JESD)                       ******************
-- ****************************************************************************
-- Filename : jesd_cpuif_pkg.vhd
-- Author   : KGO
-- Contents : Package with register addresses pertaining to jesd_cpuif.vhd
-- ****************************************************************************

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

package jesd_eval_pkg is

  -----------------------------------------------------------------------------
  -- TOP level memory map
  -----------------------------------------------------------------------------
  constant JESD_RX_BASE       : integer := 16#0#;
  constant JESD_TX_BASE       : integer := 16#1000#;
  constant JESD_TOP_BASE      : integer := 16#2000#;
  constant JESD_RECONFIG_BASE : integer := 16#3000#;

  -----------------------------------------------------------------------------
  -- TOP level registers
  -----------------------------------------------------------------------------
  constant REG_TOP_CHECK             : std_logic_vector(11 downto 0) := conv_std_logic_vector(00,10) & "00";
  constant REG_TOP_SPI_CONTROL       : std_logic_vector(11 downto 0) := conv_std_logic_vector(01,10) & "00";
  constant REG_TOP_SPI_STATUS        : std_logic_vector(11 downto 0) := conv_std_logic_vector(02,10) & "00";
  constant REG_TOP_SFP_STATUS        : std_logic_vector(11 downto 0) := conv_std_logic_vector(03,10) & "00";
  constant REG_TOP_SCRATCH_REG       : std_logic_vector(11 downto 0) := conv_std_logic_vector(04,10) & "00";
  constant REG_TOP_SERDES_LOOP       : std_logic_vector(11 downto 0) := conv_std_logic_vector(05,10) & "00";
  constant REG_TOP_SERDES_STATUS_0   : std_logic_vector(11 downto 0) := conv_std_logic_vector(06,10) & "00";
  constant REG_TOP_SERDES_STATUS_1   : std_logic_vector(11 downto 0) := conv_std_logic_vector(07,10) & "00";
  constant REG_TOP_SERDES_STATUS_2   : std_logic_vector(11 downto 0) := conv_std_logic_vector(08,10) & "00";
  constant REG_TOP_SERDES_STATUS_3   : std_logic_vector(11 downto 0) := conv_std_logic_vector(09,10) & "00";
  constant REG_TOP_SERDES_LOCKTOREF  : std_logic_vector(11 downto 0) := conv_std_logic_vector(10,10) & "00";
  constant REG_TOP_SERDES_LOCKTODATA : std_logic_vector(11 downto 0) := conv_std_logic_vector(11,10) & "00";
  constant REG_TOP_SERDES_RESET      : std_logic_vector(11 downto 0) := conv_std_logic_vector(12,10) & "00";
  constant REG_TOP_JESD_RESET        : std_logic_vector(11 downto 0) := conv_std_logic_vector(13,10) & "00";
  constant REG_TOP_DEVICE_RESET      : std_logic_vector(11 downto 0) := conv_std_logic_vector(14,10) & "00";
  constant REG_TOP_SYSTEM_PLL_STATUS : std_logic_vector(11 downto 0) := conv_std_logic_vector(15,10) & "00";
  constant REG_TOP_CPU_CLK_CNT       : std_logic_vector(11 downto 0) := conv_std_logic_vector(16,10) & "00";
  constant REG_TOP_DEVICE_CLK_CNT    : std_logic_vector(11 downto 0) := conv_std_logic_vector(17,10) & "00";
  constant REG_TOP_SYSREF_PERIOD     : std_logic_vector(11 downto 0) := conv_std_logic_vector(18,10) & "00";
  constant REG_TOP_SYSREF_CTRL       : std_logic_vector(11 downto 0) := conv_std_logic_vector(19,10) & "00";
  constant REG_TOP_CAPTURE_CTRL      : std_logic_vector(11 downto 0) := conv_std_logic_vector(20,10) & "00";
  constant REG_TOP_SPI_RATE          : std_logic_vector(11 downto 0) := conv_std_logic_vector(21,10) & "00";
  constant REG_TOP_N_CHECK           : std_logic_vector(11 downto 0) := conv_std_logic_vector(22,10) & "00";
  constant REG_TOP_RECONFIG_STATUS   : std_logic_vector(11 downto 0) := conv_std_logic_vector(23,10) & "00";
  constant REG_TOP_SAMPLE_CTRL       : std_logic_vector(11 downto 0) := conv_std_logic_vector(24,10) & "00";
  constant REG_TOP_CAPTURE_RX        : std_logic_vector(11 downto 0) := conv_std_logic_vector(512,10) & "00";
  constant REG_TOP_CAPTURE_TX        : std_logic_vector(11 downto 0) := conv_std_logic_vector(1024,10) & "00";

end jesd_eval_pkg;
