library ieee;
use ieee.std_logic_1164.all;
use IEEE.numeric_std.all;
use work.ieee_ext.all;

entity edge_detect_32 is
 
port  (     clk        : in std_logic;
            rst_n      : in std_logic;
            signal_in  : in std_logic;
            pulse_out  : out std_logic
      );
end edge_detect_32;
architecture rtl4 of edge_detect_32 is




type state_type is (IDLE,ARM,CAPT);  --type of state machine.
signal state,next_state: state_type;  --current and next state declaration.

signal SIGNAL_ASSERT: std_logic;
signal SIGNAL_DEASSERT: std_logic;
signal pulse_detect: std_logic;
signal extend_pulse: std_logic_vector(31 downto 0);

begin


SIGNAL_ASSERT   <= '1';
SIGNAL_DEASSERT <= '0';


---------------------------------------------------------------
process (clk,rst_n)
begin
 if (rst_n='0') then
  state <= idle;  --default state on reset.
elsif (rising_edge(clk)) then
  state <= next_state;   --state change.
end if;
end process;

 
--state machine process.
PROCESS (state,signal_in)
begin
  CASE state is
     WHEN IDLE =>        
	           pulse_detect <= '0';
           if(signal_in = SIGNAL_DEASSERT) then
              next_state <= ARM;
           else     
              next_state <= IDLE;
           end if;   

     WHEN ARM => 
             pulse_detect <= '0';
		     if(signal_in = SIGNAL_ASSERT) then
              next_state <= CAPT;
           else     
              next_state <= ARM;
           end if;   
			
     WHEN CAPT => 
             pulse_detect <= '1';
		     if(signal_in = SIGNAL_DEASSERT) then
              next_state <= ARM;
           else     
              next_state <= IDLE;
           end if;   

     WHEN OTHERS => 
				pulse_detect <= '0';
		      next_state <= IDLE;
			END CASE;

	END PROCESS;
			  

  extend_pulse(0) <= pulse_detect;
  extend_pulse(1) <= extend_pulse(0);
  extend_pulse(2) <= extend_pulse(1);
  extend_pulse(3) <= extend_pulse(2);
  extend_pulse(4) <= extend_pulse(3);
  extend_pulse(5) <= extend_pulse(4);
  extend_pulse(6) <= extend_pulse(5);
  extend_pulse(7) <= extend_pulse(6);
  extend_pulse(8) <= extend_pulse(7);
  extend_pulse(9) <= extend_pulse(8);
  extend_pulse(10) <= extend_pulse(9);
  extend_pulse(11) <= extend_pulse(10);
  extend_pulse(12) <= extend_pulse(11);
  extend_pulse(13) <= extend_pulse(12);
  extend_pulse(14) <= extend_pulse(13);
  extend_pulse(15) <= extend_pulse(14);
  extend_pulse(16) <= extend_pulse(15);
  extend_pulse(17) <= extend_pulse(16);
  extend_pulse(18) <= extend_pulse(17);
  extend_pulse(19) <= extend_pulse(18);
  extend_pulse(20) <= extend_pulse(19); 
  extend_pulse(21) <= extend_pulse(20);
  extend_pulse(22) <= extend_pulse(21);
  extend_pulse(23) <= extend_pulse(22);
  extend_pulse(24) <= extend_pulse(23);
  extend_pulse(25) <= extend_pulse(24);
  extend_pulse(26) <= extend_pulse(25);
  extend_pulse(27) <= extend_pulse(26);
  extend_pulse(28) <= extend_pulse(27);
  extend_pulse(29) <= extend_pulse(28);
  extend_pulse(30) <= extend_pulse(29); 
  extend_pulse(31) <= extend_pulse(30); 

  pulse_out <= extend_pulse(31) or extend_pulse(30) or extend_pulse(29) or extend_pulse(28) or
               extend_pulse(27) or extend_pulse(26) or extend_pulse(25) or extend_pulse(24) or
               extend_pulse(23) or extend_pulse(22) or extend_pulse(21) or extend_pulse(20) or
               extend_pulse(19) or extend_pulse(18) or extend_pulse(17) or extend_pulse(16) or
               extend_pulse(15) or extend_pulse(14) or extend_pulse(13) or extend_pulse(12) or
               extend_pulse(11) or extend_pulse(10) or extend_pulse(9) or extend_pulse(8) or
               extend_pulse(7) or extend_pulse(6) or extend_pulse(5) or extend_pulse(4) or
               extend_pulse(3) or extend_pulse(2) or extend_pulse(1) or extend_pulse(0);
  
			  
end rtl4;