library ieee;
use ieee.std_logic_1164.all;
use IEEE.numeric_std.all;
use work.ieee_ext.all;

entity edge_detect_6 is
 
port  (     clk        : in std_logic;
            rst_n      : in std_logic;
            signal_in  : in std_logic;
            pulse_out  : out std_logic
      );
end edge_detect_6;
architecture rtl3 of edge_detect_6 is




type state_type is (IDLE,ARM,CAPT);  --type of state machine.
signal state,next_state: state_type;  --current and next state declaration.

signal SIGNAL_ASSERT: std_logic;
signal SIGNAL_DEASSERT: std_logic;
signal pulse_detect: std_logic;
signal extend_pulse: std_logic_vector(5 downto 0);

begin


SIGNAL_ASSERT   <= '1';
SIGNAL_DEASSERT <= '0';


---------------------------------------------------------------
process (clk,rst_n)
begin
 if (rst_n='0') then
  state <= idle;  --default state on reset.
elsif (rising_edge(clk)) then
  state <= next_state;   --state change.
end if;
end process;

 
--state machine process.
PROCESS (state,signal_in)
begin
  CASE state is
     WHEN IDLE =>        
	           pulse_detect <= '0';
           if(signal_in = SIGNAL_DEASSERT) then
              next_state <= ARM;
           else     
              next_state <= IDLE;
           end if;   

     WHEN ARM => 
             pulse_detect <= '0';
		     if(signal_in = SIGNAL_ASSERT) then
              next_state <= CAPT;
           else     
              next_state <= ARM;
           end if;   
			
     WHEN CAPT => 
             pulse_detect <= '1';
		     if(signal_in = SIGNAL_DEASSERT) then
              next_state <= ARM;
           else     
              next_state <= IDLE;
           end if;   

     WHEN OTHERS => 
				pulse_detect <= '0';
		      next_state <= IDLE;
			END CASE;

	END PROCESS;
			  

  extend_pulse(0) <= pulse_detect;
  extend_pulse(1) <= extend_pulse(0);
  extend_pulse(2) <= extend_pulse(1);
  extend_pulse(3) <= extend_pulse(2);
  extend_pulse(4) <= extend_pulse(3);
  extend_pulse(5) <= extend_pulse(4);


  pulse_out <= extend_pulse(5) or extend_pulse(4) or extend_pulse(3) or extend_pulse(2) or
                extend_pulse(1) or extend_pulse(0);			  
			  
end rtl3;