#**************************************************************
# Time Information
#**************************************************************
set_time_format -unit ns -decimal_places 3

#**************************************************************
# Create Clock
#**************************************************************
create_clock -period "50 MHz" -name {cpu_clk} [get_ports { clkina_50 }]
create_clock -period "125 MHz" -name {device_clk} [get_ports { hsmc_clk }]
create_clock -period "125 MHz" -name {ref_clk} [get_ports { hsmc_clk }]


#**************************************************************
# Create Generated Clock
#**************************************************************


derive_pll_clocks
derive_clock_uncertainty

set_clock_groups -asynchronous -group [get_clocks {device_clk}] 
set_clock_groups -asynchronous -group [get_clocks {cpu_clk}] 
set_clock_groups -asynchronous -group [get_clocks {ref_clk}] 


set_false_path -from [get_clocks device_clk] -to [get_clocks *rcvdclkpma]
set_false_path -from [get_clocks cpu_clk] -to [get_clocks *rcvdclkpma]
set_false_path -from [get_clocks ref_clk] -to [get_clocks *rcvdclkpma]

set_false_path -from [get_clocks *rcvdclkpma] -to [get_clocks device_clk]
set_false_path -from [get_clocks *rcvdclkpma] -to [get_clocks cpu_clk]
set_false_path -from [get_clocks *rcvdclkpma] -to [get_clocks ref_clk]

set_false_path -from [get_clocks device_clk] -to [get_clocks *txpmalocalclk]
set_false_path -from [get_clocks cpu_clk] -to [get_clocks *txpmalocalclk]
set_false_path -from [get_clocks ref_clk] -to [get_clocks *txpmalocalclk]

set_false_path -from [get_clocks *txpmalocalclk] -to [get_clocks device_clk]
set_false_path -from [get_clocks *txpmalocalclk] -to [get_clocks cpu_clk]
set_false_path -from [get_clocks *txpmalocalclk] -to [get_clocks ref_clk]

