namespace eval ADCchanA {

    variable initialized 0
    variable ledValue 0
    variable dash_path ""
    variable dashboardActive 0
    #list ADCRaw 1 2 3 4
    set ADCRaw [::list 1 2 3 4 5 6 7 8 9 0]
    variable degrees 0



    proc init {} {

        set ::ADCchanA::initialized 1

        return -code ok
    }

    proc toggle {} {

        if { ${ADCchanA::ledValue} ==1 } {
            set ADCchanA::ledValue 0
	    return -code ok
	}

        if { ${ADCchanA::ledValue} ==0 } {
            set ADCchanA::ledValue 1
	    return -code ok
	}
        
    }

    proc ADCRead { } {


        #
        # read the spi data register, this is the thermal sample
        #
        #set ::ADCchanA::ADCRaw [expr {sin($::ADCchanA::degrees)}]
	
	#set ::ADCchanA::degrees [expr {$::ADCchanA::degrees + 1}]

    }

    proc captureMode {} {

        variable mode [ dashboard_get_property ${::ADCchanA::dash_path} viewCMcomboBoxGroup selected ]

        if { ${mode} == 0 } {

	# live data enabled
	::adcSPI::adcWrite 0x0006 0x00
        }

        if { ${mode} == 1 } {

	# internal test pattern enabled
	::adcSPI::adcWrite 0x0006 0x02
        }
    }

    proc testPatternData {} {

	variable tx_data 0

        variable mode [ dashboard_get_property ${::ADCchanA::dash_path} viewTPDcomboBoxGroup selected ]

	# get the current contents of register 0x0A	
	set readdata [::adcSPI::adcRead 0x000A]
	# keep the lower eight bits
	set readdata [ expr $readdata & 0xFF]
	puts "register 0x0A current data = $readdata"


        if { ${mode} == 1 } {

	# all zeros
	set chanAdata 0x01
        }

        if { ${mode} == 2 } {

	# all ones
	set chanAdata 0x02
        }

        if { ${mode} == 3 } {

	# toggle pattern
	set chanAdata 0x03
        }

        if { ${mode} == 4 } {

	# digital ramp
	set chanAdata 0x04
        }

        if { ${mode} == 5 } {

	# custom pattern
	set chanAdata 0x05
        }

        if { ${mode} == 6 } {

	# deskew pattern
	set chanAdata 0x06
        }

        if { ${mode} == 7 } {

	# prbs pattern
	set chanAdata 0x08
        }

        if { ${mode} == 8 } {

	# 8-point sine wave
	set chanAdata 0x09
        }

	# merge chanA write with existing register 0x0A contents
	set tx_data [ expr {$chanAdata<<4 | $readdata&0x0F}]

	puts "register 0x0A tx_data = $tx_data"

	::adcSPI::adcWrite 0x000A $tx_data



    }

    proc dashBoard {} {

        if { ${::ADCchanA::dashboardActive} == 1 } {
            return -code ok "dashboard already active"
        }

        set ::ADCchanA::dashboardActive 1
        #
        # Create dashboard 
        #
        variable ::ADCchanA::dash_path [ add_service dashboard ADCchanA "JESD204B Control Panel" "Tools/JESD204B Control Panel"]

        #
        # Set dashboard properties
        #
        dashboard_set_property ${::ADCchanA::dash_path} self developmentMode true
        dashboard_set_property ${::ADCchanA::dash_path} self itemsPerRow 1
        dashboard_set_property ${::ADCchanA::dash_path} self visible true
        
        #
        # top group widget
        #
        dashboard_add ${::ADCchanA::dash_path} topGroup group self
        dashboard_set_property ${::ADCchanA::dash_path} topGroup expandableX false
        dashboard_set_property ${::ADCchanA::dash_path} topGroup expandableY false
        dashboard_set_property ${::ADCchanA::dash_path} topGroup itemsPerRow 1
        dashboard_set_property ${::ADCchanA::dash_path} topGroup title ""


        #
        # view converter group widget
        #
        dashboard_add ${::ADCchanA::dash_path} viewConverterGroup group topGroup
        dashboard_set_property ${::ADCchanA::dash_path} viewConverterGroup expandableX false
        dashboard_set_property ${::ADCchanA::dash_path} viewConverterGroup expandableY false
        dashboard_set_property ${::ADCchanA::dash_path} viewConverterGroup itemsPerRow 3
        dashboard_set_property ${::ADCchanA::dash_path} viewConverterGroup title "Channel A"

        #
        # view capture mode widget
        #
        dashboard_add ${::ADCchanA::dash_path} viewCaptureMode group viewConverterGroup
        dashboard_set_property ${::ADCchanA::dash_path} viewCaptureMode expandableX false
        dashboard_set_property ${::ADCchanA::dash_path} viewCaptureMode expandableY false
        dashboard_set_property ${::ADCchanA::dash_path} viewCaptureMode itemsPerRow 1
        dashboard_set_property ${::ADCchanA::dash_path} viewCaptureMode title "Capture Mode"

        #
        # view capture mode combo box widget
        #
	dashboard_add ${::ADCchanA::dash_path} viewCMcomboBoxGroup comboBox viewCaptureMode
        dashboard_set_property ${::ADCchanA::dash_path} viewCMcomboBoxGroup expandableX false
	dashboard_set_property ${::ADCchanA::dash_path} viewCMcomboBoxGroup options { "Live Data" "Test Pattern Data" }
        dashboard_set_property ${::ADCchanA::dash_path} viewCMcomboBoxGroup visible true
        dashboard_set_property ${::ADCchanA::dash_path} viewCMcomboBoxGroup onChange "::ADCchanA::captureMode"

        #
        # view test pattern data widget
        #
        dashboard_add ${::ADCchanA::dash_path} viewTestPatternData group viewConverterGroup
        dashboard_set_property ${::ADCchanA::dash_path} viewTestPatternData expandableX false
        dashboard_set_property ${::ADCchanA::dash_path} viewTestPatternData expandableY false
        dashboard_set_property ${::ADCchanA::dash_path} viewTestPatternData itemsPerRow 1
        dashboard_set_property ${::ADCchanA::dash_path} viewTestPatternData title "Test Pattern Data"

        #
        # view test pattern data combo box widget
        #
	dashboard_add ${::ADCchanA::dash_path} viewTPDcomboBoxGroup comboBox viewTestPatternData
        dashboard_set_property ${::ADCchanA::dash_path} viewTPDcomboBoxGroup expandableX false
	dashboard_set_property ${::ADCchanA::dash_path} viewTPDcomboBoxGroup options { "Normal Operation" "All 0's" "All 1's" "Toggle Pattern" "Digital ramp" \
	"Custom pattern" "Deskew pattern" "PRBS pattern" "8-point sine wave" }
        dashboard_set_property ${::ADCchanA::dash_path} viewTPDcomboBoxGroup visible true
        dashboard_set_property ${::ADCchanA::dash_path} viewTPDcomboBoxGroup onChange "::ADCchanA::testPatternData"

        #
        # view channel digital gain widget
        #
        dashboard_add ${::ADCchanA::dash_path} viewChannelDigitalGain group viewConverterGroup
        dashboard_set_property ${::ADCchanA::dash_path} viewChannelDigitalGain expandableX false
        dashboard_set_property ${::ADCchanA::dash_path} viewChannelDigitalGain expandableY false
        dashboard_set_property ${::ADCchanA::dash_path} viewChannelDigitalGain itemsPerRow 1
        dashboard_set_property ${::ADCchanA::dash_path} viewChannelDigitalGain title "Gain (dB)"

        #
        # view channel digital gain combo box widget
        #
	dashboard_add ${::ADCchanA::dash_path} viewCDGcomboBoxGroup comboBox viewChannelDigitalGain
        dashboard_set_property ${::ADCchanA::dash_path} viewCDGcomboBoxGroup expandableX true
	dashboard_set_property ${::ADCchanA::dash_path} viewCDGcomboBoxGroup options { "0" "0.5" "1" "1.5" "2" "2.5" "3" "3.5" "4" "4.5" "5" "5.5" "6"}
        dashboard_set_property ${::ADCchanA::dash_path} viewCDGcomboBoxGroup visible true

        #
        # lower widgets group widget
        #
        dashboard_add ${::ADCchanA::dash_path} lowerGroup group topGroup
        dashboard_set_property ${::ADCchanA::dash_path} lowerGroup expandableX false
        dashboard_set_property ${::ADCchanA::dash_path} lowerGroup expandableY false
        dashboard_set_property ${::ADCchanA::dash_path} lowerGroup itemsPerRow 2
        dashboard_set_property ${::ADCchanA::dash_path} lowerGroup title ""

        #
        # leds group widget
        #
        dashboard_add ${::ADCchanA::dash_path} converterStatusGroup group lowerGroup
        dashboard_set_property ${::ADCchanA::dash_path} converterStatusGroup expandableX true
        dashboard_set_property ${::ADCchanA::dash_path} converterStatusGroup expandableY false
        dashboard_set_property ${::ADCchanA::dash_path} converterStatusGroup itemsPerRow 1
        #dashboard_set_property ${::ADCchanA::dash_path} converterStatusGroup title "Chan A Status"

        #
        # leds widgets
        #
        dashboard_add ${::ADCchanA::dash_path} converterLEDEnabled led converterStatusGroup
        dashboard_set_property ${::ADCchanA::dash_path} converterLEDEnabled expandableX false
        dashboard_set_property ${::ADCchanA::dash_path} converterLEDEnabled expandableY false
        dashboard_set_property ${::ADCchanA::dash_path} converterLEDEnabled text "On"
        dashboard_set_property ${::ADCchanA::dash_path} converterLEDEnabled color "green_off"

        dashboard_add ${::ADCchanA::dash_path} converterLEDDisabled led converterStatusGroup
        dashboard_set_property ${::ADCchanA::dash_path} converterLEDDisabled expandableX false
        dashboard_set_property ${::ADCchanA::dash_path} converterLEDDisabled expandableY false
        dashboard_set_property ${::ADCchanA::dash_path} converterLEDDisabled text "Off"
        dashboard_set_property ${::ADCchanA::dash_path} converterLEDDisabled color "red"

        dashboard_add ${::ADCchanA::dash_path} converterStatusButton button lowerGroup 
        dashboard_set_property ${::ADCchanA::dash_path} converterStatusButton enabled true
        dashboard_set_property ${::ADCchanA::dash_path} converterStatusButton expandableY false
        dashboard_set_property ${::ADCchanA::dash_path} converterStatusButton expandableY false
        dashboard_set_property ${::ADCchanA::dash_path} converterStatusButton text "On / Off"
        dashboard_set_property ${::ADCchanA::dash_path} converterStatusButton onClick {::ADCchanA::toggle}

        #
        # history widgets
        #
        dashboard_add ${::ADCchanA::dash_path} ADCChart lineChart topGroup 
        dashboard_set_property ${::ADCchanA::dash_path} ADCChart expandableX true
        dashboard_set_property ${::ADCchanA::dash_path} ADCChart expandableY true
        dashboard_set_property ${::ADCchanA::dash_path} ADCChart labelX "Time"
        dashboard_set_property ${::ADCchanA::dash_path} ADCChart labelY "Sample"
        #dashboard_set_property ${::ADCchanA::dash_path} ADCChart maximumItemCount [ expr 8192 ]
        dashboard_set_property ${::ADCchanA::dash_path} ADCChart title "Converter Raw Sample"
        #dashboard_set_property ${::ADCchanA::dash_path} ADCChart itemValue ${::ADCchanA::l}

        after idle ::ADCchanA::updateDashboard

        return -code ok
    }

    proc updateDashboard {} {

        ::ADCchanA::init

        if { ${::ADCchanA::dashboardActive} > 0 } {

            if { ${::ADCchanA::initialized} > 0 } {
		#dashboard_set_property ${::ADCchanA::dash_path} ADCChart itemValue ${::ADCchanA::ADCRaw}
                dashboard_set_property ${::ADCchanA::dash_path} converterStatusGroup title "Converter status"
                if { [ expr ${::ADCchanA::ledValue} & 0x01 ] } {
                    dashboard_set_property ${::ADCchanA::dash_path} converterLEDEnabled color "green_off"
		    dashboard_set_property ${::ADCchanA::dash_path} converterLEDDisabled color "red" 			
                } else {
                    dashboard_set_property ${::ADCchanA::dash_path} converterLEDEnabled color "green"
		    dashboard_set_property ${::ADCchanA::dash_path} converterLEDDisabled color "red_off"
                }
                after 300 ::ADCchanA::updateDashboard
            } else {
                dashboard_set_property ${::ADCchanA::dash_path} converterStatusGroup title "Uninitialized"
                after 1000 ::ADCchanA::updateDashboard
            }
        }
    }


::ADCchanA::dashBoard

}
