source chanOptions.tcl

namespace eval JESD204B {

    variable initialized 0
    variable ledValue 0
    variable dash_path ""
    variable dashboardActive 0
    #list ADCRaw 1 2 3 4
    set ADCRaw [::list 1 2 3 4 5 6 7 8 9 0]
    variable degrees 0



    proc init {} {

        set ::JESD204B::initialized 1

        return -code ok
    }

    proc ADCRead { } {


        #
        # read the spi data register, this is the thermal sample
        #
        #set ::JESD204B::ADCRaw [expr {sin($::JESD204B::degrees)}]
	
	#set ::JESD204B::degrees [expr {$::JESD204B::degrees + 1}]

    }

    proc captureMode {} {

        variable mode [ dashboard_get_property ${::JESD204B::dash_path} viewCMcomboBoxGroup selected ]

        if { ${mode} == 1 } {

	# live data enabled
	::adcSPI::adcWrite 0x0006 0x00
        }

        if { ${mode} == 2 } {

	# internal test pattern enabled
	::adcSPI::adcWrite 0x0006 0x02
        }
    }

    proc dashBoard {} {

        if { ${::JESD204B::dashboardActive} == 1 } {
            return -code ok "dashboard already active"
        }

        set ::JESD204B::dashboardActive 1
        #
        # Create dashboard 
        #
        variable ::JESD204B::dash_path [ add_service dashboard JESD204B "JESD204B Control Panel" "Tools/JESD204B Control Panel"]

        #
        # Set dashboard properties
        #
        dashboard_set_property ${::JESD204B::dash_path} self developmentMode true
        dashboard_set_property ${::JESD204B::dash_path} self itemsPerRow 1
        dashboard_set_property ${::JESD204B::dash_path} self visible true
        
        #
        # top group widget
        #
        dashboard_add ${::JESD204B::dash_path} topGroup group self
        dashboard_set_property ${::JESD204B::dash_path} topGroup expandableX false
        dashboard_set_property ${::JESD204B::dash_path} topGroup expandableY false
        dashboard_set_property ${::JESD204B::dash_path} topGroup itemsPerRow 1
        dashboard_set_property ${::JESD204B::dash_path} topGroup title ""

        #
        # view converter group widget
        #
        dashboard_add ${::JESD204B::dash_path} converterMode group topGroup
        dashboard_set_property ${::JESD204B::dash_path} converterMode expandableX false
        dashboard_set_property ${::JESD204B::dash_path} converterMode expandableY false
        dashboard_set_property ${::JESD204B::dash_path} converterMode itemsPerRow 2
        dashboard_set_property ${::JESD204B::dash_path} converterMode title "Converter Mode"

        #
        # view capture mode widget
        #
        dashboard_add ${::JESD204B::dash_path} viewCaptureMode group converterMode
        dashboard_set_property ${::JESD204B::dash_path} viewCaptureMode expandableX false
        dashboard_set_property ${::JESD204B::dash_path} viewCaptureMode expandableY false
        dashboard_set_property ${::JESD204B::dash_path} viewCaptureMode itemsPerRow 2
        dashboard_set_property ${::JESD204B::dash_path} viewCaptureMode title "Capture Mode"

        #
        # view capture mode combo box widget
        #
	dashboard_add ${::JESD204B::dash_path} viewCMcomboBoxGroup comboBox viewCaptureMode
        dashboard_set_property ${::JESD204B::dash_path} viewCMcomboBoxGroup expandableX false
	dashboard_set_property ${::JESD204B::dash_path} viewCMcomboBoxGroup options { "No operation" "Live Data" "Test Pattern Data" }
        dashboard_set_property ${::JESD204B::dash_path} viewCMcomboBoxGroup visible true
        dashboard_set_property ${::JESD204B::dash_path} viewCMcomboBoxGroup onChange "::JESD204B::captureMode"

        #
        # view channel group widget
        #
        dashboard_add ${::JESD204B::dash_path} channelGroup group topGroup
        dashboard_set_property ${::JESD204B::dash_path} channelGroup expandableX false
        dashboard_set_property ${::JESD204B::dash_path} channelGroup expandableY false
        dashboard_set_property ${::JESD204B::dash_path} channelGroup itemsPerRow 4
        dashboard_set_property ${::JESD204B::dash_path} channelGroup title "Channel Options"

        #
        # view channel A group widget
        #
        dashboard_add ${::JESD204B::dash_path} channelGroupA group channelGroup
        dashboard_set_property ${::JESD204B::dash_path} channelGroupA expandableX false
        dashboard_set_property ${::JESD204B::dash_path} channelGroupA expandableY false
        dashboard_set_property ${::JESD204B::dash_path} channelGroupA itemsPerRow 1
        dashboard_set_property ${::JESD204B::dash_path} channelGroupA title "Channel A"

        #
        # view channel A test pattern data widget
        #
        dashboard_add ${::JESD204B::dash_path} viewTestPatternDataA group channelGroupA
        dashboard_set_property ${::JESD204B::dash_path} viewTestPatternDataA expandableX false
        dashboard_set_property ${::JESD204B::dash_path} viewTestPatternDataA expandableY false
        dashboard_set_property ${::JESD204B::dash_path} viewTestPatternDataA itemsPerRow 1
        dashboard_set_property ${::JESD204B::dash_path} viewTestPatternDataA title "Test Pattern Data"

        #
        # view channel A test pattern data combo box widget
        #
	dashboard_add ${::JESD204B::dash_path} viewTPDcomboBoxGroupA comboBox viewTestPatternDataA
        dashboard_set_property ${::JESD204B::dash_path} viewTPDcomboBoxGroupA expandableX false
	dashboard_set_property ${::JESD204B::dash_path} viewTPDcomboBoxGroupA options { "Normal Operation" "All 0's" "All 1's" "Toggle Pattern" "Digital ramp" \
	"Custom pattern" "Deskew pattern" "PRBS pattern" "8-point sine wave" }
        dashboard_set_property ${::JESD204B::dash_path} viewTPDcomboBoxGroupA visible true
        dashboard_set_property ${::JESD204B::dash_path} viewTPDcomboBoxGroupA onChange "::chanOptions::testPatternData 0"

        #
        # view channel A digital gain widget
        #
        dashboard_add ${::JESD204B::dash_path} viewChannelDigitalGainA group channelGroupA
        dashboard_set_property ${::JESD204B::dash_path} viewChannelDigitalGainA expandableX false
        dashboard_set_property ${::JESD204B::dash_path} viewChannelDigitalGainA expandableY false
        dashboard_set_property ${::JESD204B::dash_path} viewChannelDigitalGainA itemsPerRow 1
        dashboard_set_property ${::JESD204B::dash_path} viewChannelDigitalGainA title "Gain (dB)"

        #
        # view channel A digital gain combo box widget
        #
	dashboard_add ${::JESD204B::dash_path} viewCDGcomboBoxGroupA comboBox viewChannelDigitalGainA
        dashboard_set_property ${::JESD204B::dash_path} viewCDGcomboBoxGroupA expandableX true
	dashboard_set_property ${::JESD204B::dash_path} viewCDGcomboBoxGroupA options { "0" "0.5" "1" "1.5" "2" "2.5" "3" "3.5" "4" "4.5" "5" "5.5" "6"}
        dashboard_set_property ${::JESD204B::dash_path} viewCDGcomboBoxGroupA visible true
        dashboard_set_property ${::JESD204B::dash_path} viewCDGcomboBoxGroupA onChange "::chanOptions::gainData 0"

        #
        # view channel B group widget
        #
        dashboard_add ${::JESD204B::dash_path} channelGroupB group channelGroup
        dashboard_set_property ${::JESD204B::dash_path} channelGroupB expandableX false
        dashboard_set_property ${::JESD204B::dash_path} channelGroupB expandableY false
        dashboard_set_property ${::JESD204B::dash_path} channelGroupB itemsPerRow 1
        dashboard_set_property ${::JESD204B::dash_path} channelGroupB title "Channel B"

        #
        # view channel B test pattern data widget
        #
        dashboard_add ${::JESD204B::dash_path} viewTestPatternDataB group channelGroupB
        dashboard_set_property ${::JESD204B::dash_path} viewTestPatternDataB expandableX false
        dashboard_set_property ${::JESD204B::dash_path} viewTestPatternDataB expandableY false
        dashboard_set_property ${::JESD204B::dash_path} viewTestPatternDataB itemsPerRow 1
        dashboard_set_property ${::JESD204B::dash_path} viewTestPatternDataB title "Test Pattern Data"

        #
        # view channel B test pattern data combo box widget
        #
	dashboard_add ${::JESD204B::dash_path} viewTPDcomboBoxGroupB comboBox viewTestPatternDataB
        dashboard_set_property ${::JESD204B::dash_path} viewTPDcomboBoxGroupB expandableX false
	dashboard_set_property ${::JESD204B::dash_path} viewTPDcomboBoxGroupB options { "Normal Operation" "All 0's" "All 1's" "Toggle Pattern" "Digital ramp" \
	"Custom pattern" "Deskew pattern" "PRBS pattern" "8-point sine wave" }
        dashboard_set_property ${::JESD204B::dash_path} viewTPDcomboBoxGroupB visible true
        dashboard_set_property ${::JESD204B::dash_path} viewTPDcomboBoxGroupB onChange "::chanOptions::testPatternData 1"

        #
        # view channel B digital gain widget
        #
        dashboard_add ${::JESD204B::dash_path} viewChannelDigitalGainB group channelGroupB
        dashboard_set_property ${::JESD204B::dash_path} viewChannelDigitalGainB expandableX false
        dashboard_set_property ${::JESD204B::dash_path} viewChannelDigitalGainB expandableY false
        dashboard_set_property ${::JESD204B::dash_path} viewChannelDigitalGainB itemsPerRow 1
        dashboard_set_property ${::JESD204B::dash_path} viewChannelDigitalGainB title "Gain (dB)"

        #
        # view channel B digital gain combo box widget
        #
	dashboard_add ${::JESD204B::dash_path} viewCDGcomboBoxGroupB comboBox viewChannelDigitalGainB
        dashboard_set_property ${::JESD204B::dash_path} viewCDGcomboBoxGroupB expandableX true
	dashboard_set_property ${::JESD204B::dash_path} viewCDGcomboBoxGroupB options { "0" "0.5" "1" "1.5" "2" "2.5" "3" "3.5" "4" "4.5" "5" "5.5" "6"}
        dashboard_set_property ${::JESD204B::dash_path} viewCDGcomboBoxGroupB visible true
        dashboard_set_property ${::JESD204B::dash_path} viewCDGcomboBoxGroupB onChange "::chanOptions::gainData 1"

        #
        # view channel C group widget
        #
        dashboard_add ${::JESD204B::dash_path} channelGroupC group channelGroup
        dashboard_set_property ${::JESD204B::dash_path} channelGroupC expandableX false
        dashboard_set_property ${::JESD204B::dash_path} channelGroupC expandableY false
        dashboard_set_property ${::JESD204B::dash_path} channelGroupC itemsPerRow 1
        dashboard_set_property ${::JESD204B::dash_path} channelGroupC title "Channel C"

        #
        # view channel C test pattern data widget
        #
        dashboard_add ${::JESD204B::dash_path} viewTestPatternDataC group channelGroupC
        dashboard_set_property ${::JESD204B::dash_path} viewTestPatternDataC expandableX false
        dashboard_set_property ${::JESD204B::dash_path} viewTestPatternDataC expandableY false
        dashboard_set_property ${::JESD204B::dash_path} viewTestPatternDataC itemsPerRow 1
        dashboard_set_property ${::JESD204B::dash_path} viewTestPatternDataC title "Test Pattern Data"

        #
        # view channel C test pattern data combo box widget
        #
	dashboard_add ${::JESD204B::dash_path} viewTPDcomboBoxGroupC comboBox viewTestPatternDataC
        dashboard_set_property ${::JESD204B::dash_path} viewTPDcomboBoxGroupC expandableX false
	dashboard_set_property ${::JESD204B::dash_path} viewTPDcomboBoxGroupC options { "Normal Operation" "All 0's" "All 1's" "Toggle Pattern" "Digital ramp" \
	"Custom pattern" "Deskew pattern" "PRBS pattern" "8-point sine wave" }
        dashboard_set_property ${::JESD204B::dash_path} viewTPDcomboBoxGroupC visible true
        dashboard_set_property ${::JESD204B::dash_path} viewTPDcomboBoxGroupC onChange "::chanOptions::testPatternData 2"

        #
        # view channel C digital gain widget
        #
        dashboard_add ${::JESD204B::dash_path} viewChannelDigitalGainC group channelGroupC
        dashboard_set_property ${::JESD204B::dash_path} viewChannelDigitalGainC expandableX false
        dashboard_set_property ${::JESD204B::dash_path} viewChannelDigitalGainC expandableY false
        dashboard_set_property ${::JESD204B::dash_path} viewChannelDigitalGainC itemsPerRow 1
        dashboard_set_property ${::JESD204B::dash_path} viewChannelDigitalGainC title "Gain (dB)"

        #
        # view channel C digital gain combo box widget
        #
	dashboard_add ${::JESD204B::dash_path} viewCDGcomboBoxGroupC comboBox viewChannelDigitalGainC
        dashboard_set_property ${::JESD204B::dash_path} viewCDGcomboBoxGroupC expandableX true
	dashboard_set_property ${::JESD204B::dash_path} viewCDGcomboBoxGroupC options { "0" "0.5" "1" "1.5" "2" "2.5" "3" "3.5" "4" "4.5" "5" "5.5" "6"}
        dashboard_set_property ${::JESD204B::dash_path} viewCDGcomboBoxGroupC visible true
        dashboard_set_property ${::JESD204B::dash_path} viewCDGcomboBoxGroupC onChange "::chanOptions::gainData 2"

        #
        # view channel C group widget
        #
        dashboard_add ${::JESD204B::dash_path} channelGroupD group channelGroup
        dashboard_set_property ${::JESD204B::dash_path} channelGroupD expandableX false
        dashboard_set_property ${::JESD204B::dash_path} channelGroupD expandableY false
        dashboard_set_property ${::JESD204B::dash_path} channelGroupD itemsPerRow 1
        dashboard_set_property ${::JESD204B::dash_path} channelGroupD title "Channel D"

        #
        # view channel D test pattern data widget
        #
        dashboard_add ${::JESD204B::dash_path} viewTestPatternDataD group channelGroupD
        dashboard_set_property ${::JESD204B::dash_path} viewTestPatternDataD expandableX false
        dashboard_set_property ${::JESD204B::dash_path} viewTestPatternDataD expandableY false
        dashboard_set_property ${::JESD204B::dash_path} viewTestPatternDataD itemsPerRow 1
        dashboard_set_property ${::JESD204B::dash_path} viewTestPatternDataD title "Test Pattern Data"

        #
        # view channel D test pattern data combo box widget
        #
	dashboard_add ${::JESD204B::dash_path} viewTPDcomboBoxGroupD comboBox viewTestPatternDataD
        dashboard_set_property ${::JESD204B::dash_path} viewTPDcomboBoxGroupD expandableX false
	dashboard_set_property ${::JESD204B::dash_path} viewTPDcomboBoxGroupD options { "Normal Operation" "All 0's" "All 1's" "Toggle Pattern" "Digital ramp" \
	"Custom pattern" "Deskew pattern" "PRBS pattern" "8-point sine wave" }
        dashboard_set_property ${::JESD204B::dash_path} viewTPDcomboBoxGroupD visible true
        dashboard_set_property ${::JESD204B::dash_path} viewTPDcomboBoxGroupD onChange "::chanOptions::testPatternData 3"

        #
        # view channel D digital gain widget
        #
        dashboard_add ${::JESD204B::dash_path} viewChannelDigitalGainD group channelGroupD
        dashboard_set_property ${::JESD204B::dash_path} viewChannelDigitalGainD expandableX false
        dashboard_set_property ${::JESD204B::dash_path} viewChannelDigitalGainD expandableY false
        dashboard_set_property ${::JESD204B::dash_path} viewChannelDigitalGainD itemsPerRow 1
        dashboard_set_property ${::JESD204B::dash_path} viewChannelDigitalGainD title "Gain (dB)"

        #
        # view channel D digital gain combo box widget
        #
	dashboard_add ${::JESD204B::dash_path} viewCDGcomboBoxGroupD comboBox viewChannelDigitalGainD
        dashboard_set_property ${::JESD204B::dash_path} viewCDGcomboBoxGroupD expandableX true
	dashboard_set_property ${::JESD204B::dash_path} viewCDGcomboBoxGroupD options { "0" "0.5" "1" "1.5" "2" "2.5" "3" "3.5" "4" "4.5" "5" "5.5" "6"}
        dashboard_set_property ${::JESD204B::dash_path} viewCDGcomboBoxGroupD visible true
        dashboard_set_property ${::JESD204B::dash_path} viewCDGcomboBoxGroupD onChange "::chanOptions::gainData 3"




        #after idle ::JESD204B::updateDashboard

        return -code ok
    }

    proc updateDashboard {} {

        ::JESD204B::init


    }


::JESD204B::dashBoard

}
