namespace eval adcSPI {

    variable initialized 0
    variable dash_path ""
    variable dashboardActive 0

    proc init {} {

        if { ![ namespace exists ::systemID ] } {
            return -code error "namespace systemID does not appear to exist"
        }

        if { ${::systemID::isValid} == 0 } {
            return -code ok "systemID is not validated"
        }

	#
	# initialise the adc34j45
	#

	::adcSPI::adcWrite 0x0000 0x00
	::adcSPI::adcWrite 0x0001 0xff
	::adcSPI::adcWrite 0x0002 0x00
	::adcSPI::adcWrite 0x0003 0x00
	::adcSPI::adcWrite 0x0004 0x00
	::adcSPI::adcWrite 0x0005 0x00
	::adcSPI::adcWrite 0x0006 0x04
	::adcSPI::adcWrite 0x0007 0x04
	::adcSPI::adcWrite 0x0008 0x04
	::adcSPI::adcWrite 0x0009 0x06
	::adcSPI::adcWrite 0x000a 0x00
	::adcSPI::adcWrite 0x000b 0x00
	::adcSPI::adcWrite 0x000c 0x00
	::adcSPI::adcWrite 0x000d 0x00
	::adcSPI::adcWrite 0x000e 0x00
	::adcSPI::adcWrite 0x000f 0x00
	::adcSPI::adcWrite 0x0015 0x00
	::adcSPI::adcWrite 0x0027 0x80
	::adcSPI::adcWrite 0x002a 0x00
	::adcSPI::adcWrite 0x002b 0x03
	::adcSPI::adcWrite 0x002f 0x00
	::adcSPI::adcWrite 0x0030 0x01
	::adcSPI::adcWrite 0x0031 0x0a
	::adcSPI::adcWrite 0x0034 0x20
	::adcSPI::adcWrite 0x003a 0x00
	::adcSPI::adcWrite 0x003b 0x00
	::adcSPI::adcWrite 0x003c 0x00
	::adcSPI::adcWrite 0x0122 0x02
	::adcSPI::adcWrite 0x0134 0x24
	::adcSPI::adcWrite 0x0222 0x02
	::adcSPI::adcWrite 0x0234 0x24
	::adcSPI::adcWrite 0x0422 0x02
	::adcSPI::adcWrite 0x0434 0x24
	::adcSPI::adcWrite 0x0522 0x02
	::adcSPI::adcWrite 0x0534 0x24

	::adcSPI::adcRead 0x0000 
	::adcSPI::adcRead 0x0001 
	::adcSPI::adcRead 0x0002 
	::adcSPI::adcRead 0x0003 
	::adcSPI::adcRead 0x0004 
	::adcSPI::adcRead 0x0005 
	::adcSPI::adcRead 0x0006 
	::adcSPI::adcRead 0x0007 
	::adcSPI::adcRead 0x0008 
	::adcSPI::adcRead 0x0009 
	::adcSPI::adcRead 0x000a 
	::adcSPI::adcRead 0x000b 
	::adcSPI::adcRead 0x000c 
	::adcSPI::adcRead 0x000d 
	::adcSPI::adcRead 0x000e 
	::adcSPI::adcRead 0x000f 
	::adcSPI::adcRead 0x0015 
	::adcSPI::adcRead 0x0027 
	::adcSPI::adcRead 0x002a 
	::adcSPI::adcRead 0x002b 
	::adcSPI::adcRead 0x002f 
	::adcSPI::adcRead 0x0030
	::adcSPI::adcRead 0x0031
	::adcSPI::adcRead 0x0034
	::adcSPI::adcRead 0x003a
	::adcSPI::adcRead 0x003b
	::adcSPI::adcRead 0x003c
	::adcSPI::adcRead 0x0122
	::adcSPI::adcRead 0x0134
	::adcSPI::adcRead 0x0222
	::adcSPI::adcRead 0x0234
	::adcSPI::adcRead 0x0422
	::adcSPI::adcRead 0x0434
	::adcSPI::adcRead 0x0522
	::adcSPI::adcRead 0x0534

   
        set ::adcSPI::initialized 1

        return -code ok
    }

    proc adcWrite { address wrdata } {

	#puts "write data = $wrdata"

	variable tx_data 0

	set tx_data [ expr {0x400000 | $address<<8 | $wrdata}]

        #
        # adc spi format = R/W 1 A13 A12 A11 A10 A9 A8 A7 A6 A5 A4 A3 A2 A1 A0 D7 D6 D5 D4 D3 D2 D1 D0 = 0X400000 | (ADDRESS <<8) | DATA
        #


        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::FPGA_ONLY_MASTER_ADS34J45_SPI_BASE} + ${::QSYS_HEADER::SPI_TXDATA} ] $tx_data


    }

    proc adcRead {address } {

	variable tx_data 0

	set tx_data [ expr {0xC00000 | $address<<8 | 0x00}]

        #
        # adc spi format = R/W 1 A13 A12 A11 A10 A9 A8 A7 A6 A5 A4 A3 A2 A1 D7 D6 D5 D4 D3 D2 D1 D0 = 0XC00000 | (ADDRESS <<8) | 0x00
        #


        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::FPGA_ONLY_MASTER_ADS34J45_SPI_BASE} + ${::QSYS_HEADER::SPI_TXDATA} ] $tx_data

        set rddata [ master_read_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::FPGA_ONLY_MASTER_ADS34J45_SPI_BASE} + ${::QSYS_HEADER::SPI_RXDATA} ] 1 ]

	#puts "readdata: [expr { 0x000000ff & $rddata}], from addr: $address"

	return $rddata


    }

}
