namespace eval chanOptions {

    proc testPatternData {channel} {

	variable tx_data 0

        if { ${channel} == 0} {

	set mask 0x0F
	set shift 4
	set address 0x0A

        variable mode [ dashboard_get_property ${::JESD204B::dash_path} viewTPDcomboBoxGroupA selected ]
        }

        if { ${channel} == 1} {

	set mask 0xF0
	set shift 0
	set address 0x0A

        variable mode [ dashboard_get_property ${::JESD204B::dash_path} viewTPDcomboBoxGroupB selected ]
        }

        if { ${channel} == 2} {

	set mask 0x0F
	set shift 4
	set address 0x0B

        variable mode [ dashboard_get_property ${::JESD204B::dash_path} viewTPDcomboBoxGroupC selected ]
        }

        if { ${channel} == 3} {

	set mask 0xF0
	set shift 0
	set address 0x0B

        variable mode [ dashboard_get_property ${::JESD204B::dash_path} viewTPDcomboBoxGroupD selected ]
        }

	# get the current contents of register 	
	set readdata [::adcSPI::adcRead $address]
	# keep the lower eight bits
	set readdata [ expr $readdata & 0xFF]
	#puts "register current data = $readdata"



        if { ${mode} == 1 } {

	# all zeros
	set chandata 0x01
        }

        if { ${mode} == 2 } {

	# all ones
	set chandata 0x02
        }

        if { ${mode} == 3 } {

	# toggle pattern
	set chandata 0x03
        }

        if { ${mode} == 4 } {

	# digital ramp
	set chandata 0x04
        }

        if { ${mode} == 5 } {

	# custom pattern
	set chandata 0x05
        }

        if { ${mode} == 6 } {

	# deskew pattern
	set chandata 0x06
        }

        if { ${mode} == 7 } {

	# prbs pattern
	set chandata 0x08
        }

        if { ${mode} == 8 } {

	# 8-point sine wave
	set chandata 0x09
        }

        if { ${mode} > 0 } {

	# merge chan write with existing register contents
	set tx_data [ expr {$chandata<<$shift | $readdata&$mask}]

	#puts "channel = $channel mode = $mode address = $address chandata = $chandata shift = $shift mask = $mask tx_data = $tx_data"

	::adcSPI::adcWrite $address $tx_data
	}

    }

    proc gainData {channel} {

	variable tx_data 0

        if { ${channel} == 0} {

	set mask 0x0F
	set shift 4
	set address 0x0C

	::adcSPI::adcWrite 0x02 0x02

        variable mode [ dashboard_get_property ${::JESD204B::dash_path} viewCDGcomboBoxGroupA selected ]
        }

        if { ${channel} == 1} {

	set mask 0xF0
	set shift 0
	set address 0x0C

	::adcSPI::adcWrite 0x03 0x02

        variable mode [ dashboard_get_property ${::JESD204B::dash_path} viewCDGcomboBoxGroupB selected ]
        }

        if { ${channel} == 2} {

	set mask 0x0F
	set shift 4
	set address 0x0D

	::adcSPI::adcWrite 0x04 0x02

        variable mode [ dashboard_get_property ${::JESD204B::dash_path} viewCDGcomboBoxGroupC selected ]
        }

        if { ${channel} == 3} {

	set mask 0xF0
	set shift 0
	set address 0x0D

	::adcSPI::adcWrite 0x05 0x02

        variable mode [ dashboard_get_property ${::JESD204B::dash_path} viewCDGcomboBoxGroupD selected ]
        }

	# get the current contents of register 	
	set readdata [::adcSPI::adcRead $address]
	# keep the lower eight bits
	set readdata [ expr $readdata & 0xFF]
	#puts "register current data = $readdata"



        if { ${mode} == 1 } {

	# 0 dB
	set chandata 0x00
        }

        if { ${mode} == 2 } {

	# 1 dB
	set chandata 0x01
        }

        if { ${mode} == 3 } {

	# 0.5 dB
	set chandata 0x02
        }

        if { ${mode} == 4 } {

	# 1.5 dB
	set chandata 0x03
        }

        if { ${mode} == 5 } {

	# 2.0 dB
	set chandata 0x04
        }

        if { ${mode} == 6 } {

	# 2.5 dB
	set chandata 0x05
        }

        if { ${mode} == 7 } {

	# 3.0 dB
	set chandata 0x06
        }

        if { ${mode} == 8 } {

	# 3.5 dB
	set chandata 0x07
        }

        if { ${mode} == 9 } {

	# 4.0 dB
	set chandata 0x08
        }

        if { ${mode} == 10 } {

	# 4.5 dB
	set chandata 0x09
        }

        if { ${mode} == 11 } {

	# 5.0 dB
	set chandata 0x0A
        }

        if { ${mode} == 12 } {

	# 5.5 dB
	set chandata 0x0B
        }

        if { ${mode} > 0 } {

	# merge chanA write with existing register 0x0A contents
	set tx_data [ expr {$chandata<<$shift | $readdata&$mask}]

	#puts "channel = $channel mode = $mode address = $address chandata = $chandata shift = $shift mask = $mask tx_data = $tx_data"

	::adcSPI::adcWrite $address $tx_data
	}

    }
}
