namespace eval jesd {

    variable initialized 0
    variable dash_path ""
    variable dashboardActive 0

    proc init {} {

        if { ![ namespace exists ::systemID ] } {
            return -code error "namespace systemID does not appear to exist"
        }

        if { ${::systemID::isValid} == 0 } {
            return -code ok "systemID is not validated"
        }

	#
	# initialise the hsmc jesd board
	#

	#
	# initialise the adc
	#

	::lmkSPI::init

	#
	# adc power down
	# adc reset

        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::FPGA_ONLY_MASTER_ADS_PDN_BASE}] 0x00
	after 1
        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::FPGA_ONLY_MASTER_ADS_RESET_BASE}] 0x00
	after 1
        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::FPGA_ONLY_MASTER_ADS_RESET_BASE}] 0x0F
	after 1
        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::FPGA_ONLY_MASTER_ADS_RESET_BASE}] 0x00

	#
	# initialise the adc
	#

	::adcSPI::init

	#
	# initialise the jesd ip core
	#

	#
	# reset the jesd ip core
	#

        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_SERDES_LOOP}] 0x00
        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_SERDES_RESET}] 0x0F
        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_JESD_RESET}] 0x03
        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_DEVICE_RESET}] 0x01
	after 1
        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_DEVICE_RESET}] 0x00
        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_JESD_RESET}] 0x00
        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_SERDES_RESET}] 0x00

	#
	# enable scrambling as default, we run 6G
	#

        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_RX_JESD_SCR}] 0x00
        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_TOP_SYSREF_PERIOD}] 0x06
        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_TOP_SYSREF_CTRL}] 0x03
        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_JESD_RX_SYSREF_DELAY}] 0x1F
        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_TOP_N_CHECK}] 0x0E

	#
	# initialize the jesd core registers
	#

	#
	# 4-4-2 Configuration
	#

        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_RX_JESD_ENABLEMODULE}] 0x00

        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_RX_JESD_CS}] 0x00
        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_RX_JESD_F}] 0x02
        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_RX_JESD_HD}] 0x00
        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_RX_JESD_K}] 0x09
        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_RX_JESD_L}] 0x03
        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_RX_JESD_M}] 0x03

	#
	# 12bit adsj22
	#

        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_RX_JESD_N}] 0x0B		
        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_RX_JESD_NTOTAL}] 0x0F
        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_RX_JESD_S}] 0x01
        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_RX_JESD_TAILBITS}] 0x00		

	master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::REG_RX_JESD_ENABLEMODULE}] 0x01

	# internal test pattern enabled / set to sinusoid
	::adcSPI::adcWrite 0x0006 0x02
	::adcSPI::adcWrite 0x000A 0x99
	::adcSPI::adcWrite 0x000B 0x99


        set ::jesd::initialized 1

        return -code ok
    }
}

