namespace eval lmkSPI {

    variable initialized 0
    variable dash_path ""
    variable dashboardActive 0

    proc init {} {

        if { ![ namespace exists ::systemID ] } {
            return -code error "namespace systemID does not appear to exist"
        }

        if { ${::systemID::isValid} == 0 } {
            return -code ok "systemID is not validated"
        }

	#
	# initialise the lmk04828
	#

	#	
	# init
	#

	::lmkSPI::lmkWrite 0x0000 0x90

	::lmkSPI::lmkWrite 0x0000 0x10
	::lmkSPI::lmkWrite 0x0002 0x00
	::lmkSPI::lmkWrite 0x0003 0x00
	::lmkSPI::lmkWrite 0x0004 0x00
	::lmkSPI::lmkWrite 0x0005 0x00
	::lmkSPI::lmkWrite 0x0006 0x00

	::lmkSPI::lmkWrite 0x000C 0x00
	::lmkSPI::lmkWrite 0x000D 0x00

	# 62.5 frequency was 1e
	# 50M frequency was 18
	::lmkSPI::lmkWrite 0x0100 0x1E
	::lmkSPI::lmkWrite 0x0101 0x55
	::lmkSPI::lmkWrite 0x0104 0x22
	::lmkSPI::lmkWrite 0x0105 0x00
	::lmkSPI::lmkWrite 0x0106 0xF2
	::lmkSPI::lmkWrite 0x0107 0x66

	# 62.5 frequency was 1e
	# 50M frequency was 18
	::lmkSPI::lmkWrite 0x0108 0x1E

	::lmkSPI::lmkWrite 0x0109 0x55
	::lmkSPI::lmkWrite 0x010B 0x00
	::lmkSPI::lmkWrite 0x010C 0x22
	::lmkSPI::lmkWrite 0x010D 0x00
	::lmkSPI::lmkWrite 0x010E 0xF2

	# place dclk out in hsds mode
	::lmkSPI::lmkWrite 0x010F 0X13

	# 62.5 frequency was 1e
	# 50M frequency was 18
	::lmkSPI::lmkWrite 0x0110 0x1E

	::lmkSPI::lmkWrite 0x0111 0x55
	::lmkSPI::lmkWrite 0x0113 0x00
	::lmkSPI::lmkWrite 0x0114 0x22
	::lmkSPI::lmkWrite 0x0115 0x00
	::lmkSPI::lmkWrite 0x0116 0xF2
	::lmkSPI::lmkWrite 0x0117 0x11
	::lmkSPI::lmkWrite 0x0118 0x18
	::lmkSPI::lmkWrite 0x0119 0x55
	::lmkSPI::lmkWrite 0x011B 0x00
	::lmkSPI::lmkWrite 0x011C 0x22
	::lmkSPI::lmkWrite 0x011D 0x00
	::lmkSPI::lmkWrite 0x011E 0xFB
	::lmkSPI::lmkWrite 0x011F 0x00

	::lmkSPI::lmkWrite 0x0120 0x08
	::lmkSPI::lmkWrite 0x0121 0x55
	::lmkSPI::lmkWrite 0x0123 0x00
	::lmkSPI::lmkWrite 0x0124 0x22
	::lmkSPI::lmkWrite 0x0125 0x00
	::lmkSPI::lmkWrite 0x0126 0xFB
	::lmkSPI::lmkWrite 0x0127 0x00
	::lmkSPI::lmkWrite 0x0128 0x08
	::lmkSPI::lmkWrite 0x0129 0x55
	::lmkSPI::lmkWrite 0x012B 0x00
	::lmkSPI::lmkWrite 0x012C 0x22
	::lmkSPI::lmkWrite 0x012D 0x00
	::lmkSPI::lmkWrite 0x012E 0xFB
	::lmkSPI::lmkWrite 0x012F 0x00

	::lmkSPI::lmkWrite 0x0130 0x06
	::lmkSPI::lmkWrite 0x0131 0x55
	::lmkSPI::lmkWrite 0x0133 0x00
	::lmkSPI::lmkWrite 0x0134 0x22
	::lmkSPI::lmkWrite 0x0135 0x00
	::lmkSPI::lmkWrite 0x0136 0xFB
	::lmkSPI::lmkWrite 0x0137 0x00
	::lmkSPI::lmkWrite 0x0138 0x20

	# pulser sysref
	::lmkSPI::lmkWrite 0x0139 0x02

	# 13a(02) 13b(58) set for 5 MHz SYSREF - BWL 4/21
	::lmkSPI::lmkWrite 0x013A 0x09

	# 13a(09) 13b(60) set for 1.25M sysref - JT  4/24
	::lmkSPI::lmkWrite 0x013B 0x60
	::lmkSPI::lmkWrite 0x013C 0x00
	::lmkSPI::lmkWrite 0x013D 0x08
	::lmkSPI::lmkWrite 0x013E 0x03
	::lmkSPI::lmkWrite 0x013F 0x00

	::lmkSPI::lmkWrite 0x0140 0x03
	::lmkSPI::lmkWrite 0x0141 0x00
	::lmkSPI::lmkWrite 0x0142 0x00
	::lmkSPI::lmkWrite 0x0143 0x51
	::lmkSPI::lmkWrite 0x0144 0x83
	::lmkSPI::lmkWrite 0x0145 0x7F
	::lmkSPI::lmkWrite 0x0146 0x0F
	::lmkSPI::lmkWrite 0x0147 0x3A
	::lmkSPI::lmkWrite 0x0148 0x02
	::lmkSPI::lmkWrite 0x0149 0x42
	::lmkSPI::lmkWrite 0x014A 0x33
	::lmkSPI::lmkWrite 0x014B 0x16
	::lmkSPI::lmkWrite 0x014C 0x00
	::lmkSPI::lmkWrite 0x014D 0x00
	::lmkSPI::lmkWrite 0x014E 0xC0
	::lmkSPI::lmkWrite 0x014F 0x7F

	::lmkSPI::lmkWrite 0x0150 0x03
	::lmkSPI::lmkWrite 0x0151 0x02
	::lmkSPI::lmkWrite 0x0152 0x00
	::lmkSPI::lmkWrite 0x0153 0x00
	::lmkSPI::lmkWrite 0x0154 0x01
	::lmkSPI::lmkWrite 0x0155 0x00
	::lmkSPI::lmkWrite 0x0156 0x01
	::lmkSPI::lmkWrite 0x0157 0x00
	::lmkSPI::lmkWrite 0x0158 0x00
	::lmkSPI::lmkWrite 0x0159 0x00
	::lmkSPI::lmkWrite 0x015A 0x0A
	::lmkSPI::lmkWrite 0x015B 0x1F
	::lmkSPI::lmkWrite 0x015C 0x20
	::lmkSPI::lmkWrite 0x015D 0x00
	::lmkSPI::lmkWrite 0x015E 0x00
	::lmkSPI::lmkWrite 0x015F 0xBF

	::lmkSPI::lmkWrite 0x0160 0x00
	::lmkSPI::lmkWrite 0x0161 0x01
	::lmkSPI::lmkWrite 0x0162 0x44
	::lmkSPI::lmkWrite 0x0163 0x00
	::lmkSPI::lmkWrite 0x0164 0x00
	::lmkSPI::lmkWrite 0x0165 0x0C

	# Program before PLL2 register to optimize VCO1 noise performance
	::lmkSPI::lmkWrite 0x017C 0x15
	::lmkSPI::lmkWrite 0x017D 0x33

	# PLL2 registers
	::lmkSPI::lmkWrite 0x0166 0x00
	::lmkSPI::lmkWrite 0x0167 0x00
	::lmkSPI::lmkWrite 0x0168 0x0F
	::lmkSPI::lmkWrite 0x0169 0x59
	::lmkSPI::lmkWrite 0x016A 0x40
	::lmkSPI::lmkWrite 0x016B 0x01
	::lmkSPI::lmkWrite 0x016C 0x00
	::lmkSPI::lmkWrite 0x016D 0x00
	::lmkSPI::lmkWrite 0x016E 0x13

	::lmkSPI::lmkWrite 0x0173 0x00

	::lmkSPI::lmkWrite 0x0182 0x00
	::lmkSPI::lmkWrite 0x0183 0x00
	::lmkSPI::lmkWrite 0x0184 0x00
	::lmkSPI::lmkWrite 0x0185 0x00
	::lmkSPI::lmkWrite 0x0188 0x00

	::lmkSPI::lmkWrite 0x01FFD 0X00
	::lmkSPI::lmkWrite 0x01FFE 0X00
	::lmkSPI::lmkWrite 0x01FFF 0X53

	# sysref test
	::lmkSPI::lmkWrite 0x0139 0x00
	::lmkSPI::lmkWrite 0x0140 0x00
	::lmkSPI::lmkWrite 0x0143 0x91
	::lmkSPI::lmkWrite 0x013E 0x03
	::lmkSPI::lmkWrite 0x0144 0x00
	::lmkSPI::lmkWrite 0x0143 0xB2
	::lmkSPI::lmkWrite 0x0143 0x92
	::lmkSPI::lmkWrite 0x0144 0xFF
	::lmkSPI::lmkWrite 0x0143 0x12
	::lmkSPI::lmkWrite 0x0139 0x02
	::lmkSPI::lmkWrite 0x0143 0x12

	::lmkSPI::lmkRead 0x0000

	::lmkSPI::lmkRead 0x0000
	::lmkSPI::lmkRead 0x0002
	::lmkSPI::lmkRead 0x0003
	::lmkSPI::lmkRead 0x0004
	::lmkSPI::lmkRead 0x0005
	::lmkSPI::lmkRead 0x0006

	::lmkSPI::lmkRead 0x000C
	::lmkSPI::lmkRead 0x000D

	::lmkSPI::lmkRead 0x0100
	::lmkSPI::lmkRead 0x0101
	::lmkSPI::lmkRead 0x0104
	::lmkSPI::lmkRead 0x0105
	::lmkSPI::lmkRead 0x0106
	::lmkSPI::lmkRead 0x0107

	::lmkSPI::lmkRead 0x0108

	::lmkSPI::lmkRead 0x0109
	::lmkSPI::lmkRead 0x010B
	::lmkSPI::lmkRead 0x010C
	::lmkSPI::lmkRead 0x010D
	::lmkSPI::lmkRead 0x010E

	::lmkSPI::lmkRead 0x010F

	::lmkSPI::lmkRead 0x0110

	::lmkSPI::lmkRead 0x0111
	::lmkSPI::lmkRead 0x0113
	::lmkSPI::lmkRead 0x0114
	::lmkSPI::lmkRead 0x0115
	::lmkSPI::lmkRead 0x0116
	::lmkSPI::lmkRead 0x0117
	::lmkSPI::lmkRead 0x0118
	::lmkSPI::lmkRead 0x0119
	::lmkSPI::lmkRead 0x011B
	::lmkSPI::lmkRead 0x011C
	::lmkSPI::lmkRead 0x011D
	::lmkSPI::lmkRead 0x011E
	::lmkSPI::lmkRead 0x011F

	::lmkSPI::lmkRead 0x0120
	::lmkSPI::lmkRead 0x0121
	::lmkSPI::lmkRead 0x0123
	::lmkSPI::lmkRead 0x0124
	::lmkSPI::lmkRead 0x0125
	::lmkSPI::lmkRead 0x0126
	::lmkSPI::lmkRead 0x0127
	::lmkSPI::lmkRead 0x0128
	::lmkSPI::lmkRead 0x0129
	::lmkSPI::lmkRead 0x012B
	::lmkSPI::lmkRead 0x012C
	::lmkSPI::lmkRead 0x012D
	::lmkSPI::lmkRead 0x012E
	::lmkSPI::lmkRead 0x012F

	::lmkSPI::lmkRead 0x0130
	::lmkSPI::lmkRead 0x0131
	::lmkSPI::lmkRead 0x0133
	::lmkSPI::lmkRead 0x0134
	::lmkSPI::lmkRead 0x0135
	::lmkSPI::lmkRead 0x0136
	::lmkSPI::lmkRead 0x0137
	::lmkSPI::lmkRead 0x0138

	::lmkSPI::lmkRead 0x0139

	::lmkSPI::lmkRead 0x013A

	::lmkSPI::lmkRead 0x013B
	::lmkSPI::lmkRead 0x013C
	::lmkSPI::lmkRead 0x013D
	::lmkSPI::lmkRead 0x013E
	::lmkSPI::lmkRead 0x013F

	::lmkSPI::lmkRead 0x0140
	::lmkSPI::lmkRead 0x0141
	::lmkSPI::lmkRead 0x0142
	::lmkSPI::lmkRead 0x0143
	::lmkSPI::lmkRead 0x0144
	::lmkSPI::lmkRead 0x0145
	::lmkSPI::lmkRead 0x0146
	::lmkSPI::lmkRead 0x0147
	::lmkSPI::lmkRead 0x0148
	::lmkSPI::lmkRead 0x0149
	::lmkSPI::lmkRead 0x014A
	::lmkSPI::lmkRead 0x014B
	::lmkSPI::lmkRead 0x014C
	::lmkSPI::lmkRead 0x014D
	::lmkSPI::lmkRead 0x014E
	::lmkSPI::lmkRead 0x014F

	::lmkSPI::lmkRead 0x0150
	::lmkSPI::lmkRead 0x0151
	::lmkSPI::lmkRead 0x0152
	::lmkSPI::lmkRead 0x0153
	::lmkSPI::lmkRead 0x0154
	::lmkSPI::lmkRead 0x0155
	::lmkSPI::lmkRead 0x0156
	::lmkSPI::lmkRead 0x0157
	::lmkSPI::lmkRead 0x0158
	::lmkSPI::lmkRead 0x0159
	::lmkSPI::lmkRead 0x015A
	::lmkSPI::lmkRead 0x015B
	::lmkSPI::lmkRead 0x015C
	::lmkSPI::lmkRead 0x015D
	::lmkSPI::lmkRead 0x015E
	::lmkSPI::lmkRead 0x015F

	::lmkSPI::lmkRead 0x0160
	::lmkSPI::lmkRead 0x0161
	::lmkSPI::lmkRead 0x0162
	::lmkSPI::lmkRead 0x0163
	::lmkSPI::lmkRead 0x0164
	::lmkSPI::lmkRead 0x0165


	::lmkSPI::lmkRead 0x017C
	::lmkSPI::lmkRead 0x017D


	::lmkSPI::lmkRead 0x0166
	::lmkSPI::lmkRead 0x0167
	::lmkSPI::lmkRead 0x0168
	::lmkSPI::lmkRead 0x0169
	::lmkSPI::lmkRead 0x016A
	::lmkSPI::lmkRead 0x016B
	::lmkSPI::lmkRead 0x016C
	::lmkSPI::lmkRead 0x016D
	::lmkSPI::lmkRead 0x016E

	::lmkSPI::lmkRead 0x0173

	::lmkSPI::lmkRead 0x0182
	::lmkSPI::lmkRead 0x0183
	::lmkSPI::lmkRead 0x0184
	::lmkSPI::lmkRead 0x0185
	::lmkSPI::lmkRead 0x0188

	::lmkSPI::lmkRead 0x01FFD
	::lmkSPI::lmkRead 0x01FFE
	::lmkSPI::lmkRead 0x01FFF


	::lmkSPI::lmkRead 0x0139
	::lmkSPI::lmkRead 0x0140
	::lmkSPI::lmkRead 0x0143
	::lmkSPI::lmkRead 0x013E
	::lmkSPI::lmkRead 0x0144
	::lmkSPI::lmkRead 0x0143
	::lmkSPI::lmkRead 0x0143
	::lmkSPI::lmkRead 0x0144
	::lmkSPI::lmkRead 0x0143
	::lmkSPI::lmkRead 0x0139
	::lmkSPI::lmkRead 0x0143


   
        set ::lmkSPI::initialized 1

        return -code ok
    }

    proc lmkWrite { address wrdata } {

	variable tx_data 0

	set tx_data [ expr {0x000000 | $address<<8 | $wrdata}]

        #
        # lmk spi format = R/W W1 W0 A12 A11 A10 A9 A8 A7 A6 A5 A4 A3 A2 A1 D7 D6 D5 D4 D3 D2 D1 D0 = 0X400000 | (ADDRESS <<8) | DATA
        #


        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::FPGA_ONLY_MASTER_LMK04826_SPI_BASE} + ${::QSYS_HEADER::SPI_TXDATA} ] $tx_data


    }

    proc lmkRead {address } {

	variable tx_data 0

	set tx_data [ expr {0x800000 | $address<<8 | 0x00}]

        #
        # lmk spi format = R/W W1 W0 A12 A11 A10 A9 A8 A7 A6 A5 A4 A3 A2 A1 D7 D6 D5 D4 D3 D2 D1 D0 = 0XC00000 | (ADDRESS <<8) | 0x00
        #


        master_write_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::FPGA_ONLY_MASTER_LMK04826_SPI_BASE} + ${::QSYS_HEADER::SPI_TXDATA} ] $tx_data

        set rddata [ master_read_32 ${::boardInit::masterPath} [ expr ${::QSYS_HEADER::FPGA_ONLY_MASTER_LMK04826_SPI_BASE} + ${::QSYS_HEADER::SPI_RXDATA} ] 1 ]

	#puts "readdata: [expr { 0x000000ff & $rddata}], from addr: $address"

	return $rddata


    }

}
